<?php

namespace Controllers;

use Zeedhi\Framework\DTO;

class LockLista extends \Teknisa\GER\Controllers\TeknisaCrud
{
    protected $dataSourceName = 'lock_lista';
    protected $newCode;
    protected $environment;

    public function __construct($crudService, $parameterBag, $environment, $newCode)
    {
        parent::__construct($crudService, $parameterBag);
        $this->environment = $environment;
        $this->newCode = $newCode;
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response)
    {
        try {
            $filterCriteria = $request->getFilterCriteria();
		    $filterCriteria->addCondition("CDOPERADOR", $this->environment->getCdoperador());
            parent::find($request, $response);
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }

    public function save(DTO\Request $request, DTO\Response $response)
    {
        try {
            $row = $request->getRow();
            $nrseqlocklist = $this->newCode->getCodeByTableName('LOCKLISTA', $this->environment->getNrorgTrab(), 1, 10, false);
            $row['NRSEQLOCKLIST'] = $nrseqlocklist;
            $row['CDOPERADOR'] = $this->environment->getCdoperador();
            parent::save($request, $response);
        } catch (\Exception $e) {
            $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
        }
    }
}
