<?php
namespace Controllers;

use Services\SendEmailService;

class SendEmailController {

    public function __construct(SendEmailService $service) {
        $this->service = $service;
    }
    
    public function sendMail($params) {
        $message = $this->service->getMessage($params);
        $this->service->sendEMail($params, $message);
    }
    
    public function sendErrorReport($params, $cdSupplier, $supplierName, $numOrders) {
        $message = $this->service->getErrorReportMessage($cdSupplier, $supplierName, $numOrders);
        $this->service->sendEMail($params, $message);
    }
    
    public function sendMailSupplyTek($email, $idAplicativo = 'SUPPLYTEK', $filial = null)
    {
        $this->service->sendMailSupplyTek($email, $idAplicativo, $filial);
    }
}