<?php

namespace Modules\Cotacao\Modules\Pedido\Controllers;

use Zeedhi\Framework\DTO;

class ImportacaoRFPReportController extends \Zeedhi\Framework\Controller\Report
{
    protected $stNomeRel;
    protected $stExtensao;

    protected $reportService;
    protected $environment;
    protected $qr2Strategy;
    protected $birtStrategy;

    public function __construct($reportService, $environment, $qr2Strategy, $birtStrategy)
    {
        parent::__construct($reportService);
        $this->environment = $environment;
        $this->qr2Strategy = $qr2Strategy;
        $this->birtStrategy = $birtStrategy;
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response)
    {
        $row = $request->getRow();
        $row["DTVALIDADEINICIAL"] = $row["DTVALIDADE"]["formattedStart"];
        $row["DTVALIDADEFINAL"] = $row["DTVALIDADE"]["formattedEnd"];
        $row["DTIMPINIAL"] = $row["DTIMPORTACAO"]["formattedStart"];
        $row["DTIMPFINAL"] = $row["DTIMPORTACAO"]["formattedEnd"];
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        $this->stNomeRel = $this->getReportName($row);
        $row['NRORG'] = $this->environment->getNrOrg();
        $this->reportMapping[$this->stNomeRel] =
            array(
                'strategy' => 'BIRT',
                'parameterMapping' =>
                array(
                    "COMPRADOR"         => "COMPRADOR",
                    "CDFORNECED"        => "CDFORNECED",
                    "CDREGIAO"          => "CDREGIAO",
                    "DTVALIDADEINICIAL" => "DTVALIDADEINICIAL",
                    "DTVALIDADEFINAL"   => "DTVALIDADEFINAL",
                    "DTIMPINIAL"        => "DTIMPINIAL",
                    "DTIMPFINAL"        => "DTIMPFINAL",
                    "NRORG"             => "NRORG"
                ),
            );
    }
}
