/* Sistemas Integrados TEKNISA

Nome: 5013_FISFUNS_CTBL_PRODUTO.SQL

@C:\Web_411\Sql\End_Conv\SqlServer\5013_FISFUNS_CTBL_PRODUTO.SQL

Descrio:
Rotina para buscar a conta contabil dos produtos da nota fiscal.

P_CDPRODUTO       - Cdigo do produto da nota fiscal.
P_IDENTRSAID      - identificador de entrada\saida da nota fiscal.

PARA DEBUGAR
-- SET SERVEROUTPUT ON
-- DBMS_OUTPUT.PUT_LINE('xx');

Criao:
14/04/2008 - Dione Ferreira
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'CTBL_PRODUTO' AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION CTBL_PRODUTO
GO

CREATE FUNCTION CTBL_PRODUTO(
   @P_CDPRODUTO  VARCHAR(10),
   @P_IDENTRSAID VARCHAR(1)) RETURNS VARCHAR(20)
AS
BEGIN
   DECLARE @V_CDCTBLENTRPR   VARCHAR(20);
   DECLARE @V_CDCTBLSAIDPR   VARCHAR(20);
   DECLARE @V_CDARVPROD      VARCHAR(20);
   DECLARE @V_CDCTBLPROD     VARCHAR(20);

   SET @V_CDCTBLENTRPR = NULL;
   SET @V_CDCTBLSAIDPR = NULL;
   SET @V_CDARVPROD    = NULL;
   SET @V_CDCTBLPROD   = NULL;

   SELECT @V_CDARVPROD = MAX(CDARVPROD)
     FROM PRODUTO
    WHERE CDPRODUTO = @P_CDPRODUTO;

   SELECT @V_CDCTBLENTRPR = MAX(PR.CDCTBLENTRPR),
          @V_CDCTBLSAIDPR = MAX(PR.CDCTBLSAIDPR)
     FROM PRODUTO PR,
          (SELECT MAX(CDARVPROD) AS CDARVPROD
             FROM PRODUTO C
            WHERE (CHARINDEX(RTRIM(C.CDARVPROD),@V_CDARVPROD) = 1)
              AND NOT(CASE @P_IDENTRSAID
                  WHEN 'E'
                  THEN CDCTBLENTRPR
                  ELSE CDCTBLSAIDPR END IS NULL)) P
    WHERE PR.CDARVPROD = P.CDARVPROD;

   IF @P_IDENTRSAID = 'E' BEGIN
      SET @V_CDCTBLPROD = @V_CDCTBLENTRPR;
   END
   ELSE BEGIN
      SET @V_CDCTBLPROD = @V_CDCTBLSAIDPR;
   END;
   RETURN(@V_CDCTBLPROD);
END
GO


-- VERSAO --
EXEC ATUVEROBJ 'CTBL_PRODUTO','5.05.025';
GO

